// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/user"
	"go.phucam.tv/ent/userpassword"
)

// UserPasswordCreate is the builder for creating a UserPassword entity.
type UserPasswordCreate struct {
	config
	mutation *UserPasswordMutation
	hooks    []Hook
}

// SetHashedValue sets the "hashedValue" field.
func (upc *UserPasswordCreate) SetHashedValue(s string) *UserPasswordCreate {
	upc.mutation.SetHashedValue(s)
	return upc
}

// SetIsActive sets the "isActive" field.
func (upc *UserPasswordCreate) SetIsActive(b bool) *UserPasswordCreate {
	upc.mutation.SetIsActive(b)
	return upc
}

// SetCreatedAt sets the "createdAt" field.
func (upc *UserPasswordCreate) SetCreatedAt(u uint32) *UserPasswordCreate {
	upc.mutation.SetCreatedAt(u)
	return upc
}

// SetID sets the "id" field.
func (upc *UserPasswordCreate) SetID(i int) *UserPasswordCreate {
	upc.mutation.SetID(i)
	return upc
}

// SetUserID sets the "user" edge to the User entity by ID.
func (upc *UserPasswordCreate) SetUserID(id int) *UserPasswordCreate {
	upc.mutation.SetUserID(id)
	return upc
}

// SetUser sets the "user" edge to the User entity.
func (upc *UserPasswordCreate) SetUser(u *User) *UserPasswordCreate {
	return upc.SetUserID(u.ID)
}

// Mutation returns the UserPasswordMutation object of the builder.
func (upc *UserPasswordCreate) Mutation() *UserPasswordMutation {
	return upc.mutation
}

// Save creates the UserPassword in the database.
func (upc *UserPasswordCreate) Save(ctx context.Context) (*UserPassword, error) {
	var (
		err  error
		node *UserPassword
	)
	if len(upc.hooks) == 0 {
		if err = upc.check(); err != nil {
			return nil, err
		}
		node, err = upc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*UserPasswordMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = upc.check(); err != nil {
				return nil, err
			}
			upc.mutation = mutation
			if node, err = upc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(upc.hooks) - 1; i >= 0; i-- {
			if upc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = upc.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, upc.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*UserPassword)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from UserPasswordMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (upc *UserPasswordCreate) SaveX(ctx context.Context) *UserPassword {
	v, err := upc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (upc *UserPasswordCreate) Exec(ctx context.Context) error {
	_, err := upc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (upc *UserPasswordCreate) ExecX(ctx context.Context) {
	if err := upc.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (upc *UserPasswordCreate) check() error {
	if _, ok := upc.mutation.HashedValue(); !ok {
		return &ValidationError{Name: "hashedValue", err: errors.New(`ent: missing required field "UserPassword.hashedValue"`)}
	}
	if _, ok := upc.mutation.IsActive(); !ok {
		return &ValidationError{Name: "isActive", err: errors.New(`ent: missing required field "UserPassword.isActive"`)}
	}
	if _, ok := upc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "createdAt", err: errors.New(`ent: missing required field "UserPassword.createdAt"`)}
	}
	if _, ok := upc.mutation.UserID(); !ok {
		return &ValidationError{Name: "user", err: errors.New(`ent: missing required edge "UserPassword.user"`)}
	}
	return nil
}

func (upc *UserPasswordCreate) sqlSave(ctx context.Context) (*UserPassword, error) {
	_node, _spec := upc.createSpec()
	if err := sqlgraph.CreateNode(ctx, upc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = int(id)
	}
	return _node, nil
}

func (upc *UserPasswordCreate) createSpec() (*UserPassword, *sqlgraph.CreateSpec) {
	var (
		_node = &UserPassword{config: upc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: userpassword.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: userpassword.FieldID,
			},
		}
	)
	if id, ok := upc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := upc.mutation.HashedValue(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: userpassword.FieldHashedValue,
		})
		_node.HashedValue = value
	}
	if value, ok := upc.mutation.IsActive(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeBool,
			Value:  value,
			Column: userpassword.FieldIsActive,
		})
		_node.IsActive = value
	}
	if value, ok := upc.mutation.CreatedAt(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeUint32,
			Value:  value,
			Column: userpassword.FieldCreatedAt,
		})
		_node.CreatedAt = value
	}
	if nodes := upc.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: true,
			Table:   userpassword.UserTable,
			Columns: []string{userpassword.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: user.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.user_password = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// UserPasswordCreateBulk is the builder for creating many UserPassword entities in bulk.
type UserPasswordCreateBulk struct {
	config
	builders []*UserPasswordCreate
}

// Save creates the UserPassword entities in the database.
func (upcb *UserPasswordCreateBulk) Save(ctx context.Context) ([]*UserPassword, error) {
	specs := make([]*sqlgraph.CreateSpec, len(upcb.builders))
	nodes := make([]*UserPassword, len(upcb.builders))
	mutators := make([]Mutator, len(upcb.builders))
	for i := range upcb.builders {
		func(i int, root context.Context) {
			builder := upcb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*UserPasswordMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, upcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, upcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, upcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (upcb *UserPasswordCreateBulk) SaveX(ctx context.Context) []*UserPassword {
	v, err := upcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (upcb *UserPasswordCreateBulk) Exec(ctx context.Context) error {
	_, err := upcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (upcb *UserPasswordCreateBulk) ExecX(ctx context.Context) {
	if err := upcb.Exec(ctx); err != nil {
		panic(err)
	}
}
